// EPCDemoView.h : interface of the CEPCDemoView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_EPCDEMOVIEW_H__5C9FB103_2E71_4813_8DE0_51CA34A9C8F3__INCLUDED_)
#define AFX_EPCDEMOVIEW_H__5C9FB103_2E71_4813_8DE0_51CA34A9C8F3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define	STATUS_Init					(0)
#define	STATUS_CommOpen				(1)
#define	STATUS_ReadingTag			(2)

#define	TIMER_ReadTag				(10000)
#define	LEN_TagID					(12)
#define	LEN_TagIDUseful				(3)
#define	NUM_MaxTag					(1024 * 1024)

typedef struct {
	BYTE	tagID[LEN_TagID];
	time_t	time;
} STagID;

class CEPCDemoView : public CFormView
{
protected: // create from serialization only
	CEPCDemoView();
	DECLARE_DYNCREATE(CEPCDemoView)

public:
	//{{AFX_DATA(CEPCDemoView)
	enum{ IDD = IDD_EPCDEMO_FORM };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

// Attributes
public:
	CEPCDemoDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEPCDemoView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnInitialUpdate(); // called first time after construct
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CEPCDemoView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
	
public:
	void	Initialize(void);
	void	Finalize(void);

	void	SetStatus(int status);
	int		GetStatus(void);

	void	ReadTagProcess(void);
	void	SaveTagsToFile(LPCTSTR path);

protected:
	void	DisplayInNewLine(UINT strID);
	void	DisplayInNewLine(LPCTSTR str);
	void	Display(UINT strID);
	void	Display(LPCTSTR str);
	bool	IsNewTag(BYTE tagID[LEN_TagID]);
	void	GetTagIDDecStr(const BYTE tagID[LEN_TagID], CString* str);
	void	GetTagIDHexStr(const BYTE tagID[LEN_TagID], CString* str);
	void	GetTimeStr(time_t time, CString* str);
	void	MakeToSaveFilePathByTime(CString* fullPath, CString* fileName);
	void	GetModuleDir(CString* path);

public:
	static	bool IsHexChar(char ch);
	static	bool StrToHexNums(LPCTSTR str, BYTE* hexBuf, BYTE* len);

protected:
	HANDLE	m_hCom;
	int		m_status;
public:
	static	int		m_tagIDNum;
	static	STagID	m_tagIDs[NUM_MaxTag];
// Generated message map functions
protected:
	//{{AFX_MSG(CEPCDemoView)
	afx_msg void OnBUTTONConnect();
	afx_msg void OnBUTTONDisconnect();
	afx_msg void OnBUTTONClear();
	afx_msg void OnBUTTONStart();
	afx_msg void OnBUTTONStop();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in EPCDemoView.cpp
inline CEPCDemoDoc* CEPCDemoView::GetDocument()
   { return (CEPCDemoDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EPCDEMOVIEW_H__5C9FB103_2E71_4813_8DE0_51CA34A9C8F3__INCLUDED_)
