// EPCSDK.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "EPCSDK.h"
#include "CommSerial.h"

#define	LEN_Tag					(12)
#define LEN_TagEPCData			(8)
#define SIZE_COMMBuffer			(1024 * 4)

static unsigned char buffer[SIZE_COMMBuffer];

HANDLE OpenComm(int portNo)
{
	return ::COMMOpen(portNo);
}

void CloseComm(HANDLE hCom)
{
	::COMMClose(hCom);
}

bool ReadFirmwareVersion(HANDLE hCom, int* main, int* sub,BYTE ReaderAddr)
{
	bool ret = FALSE;
	buffer[0] = 0xA0;
	buffer[1] = 0x03;
	buffer[2] = 0x6A;
    buffer[3] = ReaderAddr;
	buffer[4] = ::GetCheckSum(buffer, 4); //ӻأE0 05 6Aͷ00usercode 03 56 汾ţ58checksum  
	::COMMPurgeComm(hCom);
	if(::COMMSendData(hCom, (const char*)buffer, 5) == 5)
	{
		::memset(buffer, 0, 7 * sizeof(BYTE));
		if(::COMMReceiveData(hCom, (char*)buffer, 7) == 7)
		{
			if(	   buffer[0] == 0xE0 
				&& buffer[1] == 0x05 
				&& buffer[2] == 0x6A 
				&& buffer[6] == ::GetCheckSum(buffer, 6)	)
				*main = buffer[4];
				*sub = buffer[5];
				ret = TRUE;
		}
	}
	return ret;
}

bool StopWorking(HANDLE hCom,BYTE ReaderAddr)
{
	bool ret = false;
	buffer[0] = 0xA0;
	buffer[1] = 0x03;
	buffer[2] = 0x50;
	buffer[3] = ReaderAddr;
	buffer[4] = ::GetCheckSum(buffer, 4);
	::COMMPurgeComm(hCom);
	if(::COMMSendData(hCom, (const char*)buffer, 5) == 5)
	{
		::memset(buffer, 0, 6 * sizeof(unsigned char));
		if(::COMMReceiveData(hCom, (char*)buffer, 6) == 6)
		{
			if(	   buffer[0] == 0xE4 
				&& buffer[1] == 0x04 
				&& buffer[2] == 0x50 
				&& buffer[5] == ::GetCheckSum(buffer, 5)	)
				if(buffer[4] == 0x00)
					ret = true;
		}
	}
	return ret;
}

//A0 03 65 00 F8
//ӻأE4  04  65  usercode  status  checksum
bool ResetReader(HANDLE hCom,BYTE ReaderAddr)
{
	bool ret = FALSE;
	buffer[0] = 0xA0;
	buffer[1] = 0x03;
	buffer[2] = 0x65;
    buffer[3] = ReaderAddr;
	buffer[4] = ::GetCheckSum(buffer, 4);
	::COMMPurgeComm(hCom);
	if(::COMMSendData(hCom, (const char*)buffer, 5) == 5)
	{
		::memset(buffer, 0, 6 * sizeof(BYTE));
		if(::COMMReceiveData(hCom, (char*)buffer, 6) == 6)
		{
			if(	   buffer[0] == 0xE4 
				&& buffer[1] == 0x04 
				&& buffer[2] == 0x65 
				&& buffer[5] == ::GetCheckSum(buffer, 5)	)
				if(buffer[4] == 0x00)
					ret = TRUE;
		}
	}
	return ret;
}
//---------------------------------------------------------------------------------------
// A0 03 82 00 DB         
//ӻأ   E0 10 82 00 01 FF FF 11 22 33 44 55 66 77 88 00 0B 20 
BOOL IdentifySingleTag(HANDLE hCom, BYTE* tagID, BYTE* antennaNo,BYTE ReaderAddr)
{
	BOOL ret = FALSE;
	antennaNo=NULL;
	buffer[0] = 0xA0;
	buffer[1] = 0x03;
	buffer[2] = 0x82;
	buffer[3] = ReaderAddr; 
	buffer[4] = ::GetCheckSum(buffer, 4);
	::COMMPurgeComm(hCom);
	if(::COMMSendData(hCom, (const char*)buffer, 5) == 5)
	{
		::memset(buffer, 0, 18 * sizeof(BYTE));
		if(::COMMReceiveData(hCom, (char*)buffer, 18) == 18)
		{
			if(	   buffer[0] == 0xE0 
				&& buffer[1] == 0x10 
				&& buffer[2] == 0x82 
				&& buffer[17] == ::GetCheckSum(buffer, 17)	)
				::memcpy(tagID, &buffer[5], LEN_Tag);
				if(antennaNo != NULL)
					*antennaNo = buffer[4];
				ret = TRUE;
		}
	}
	return ret;
}

bool IdentifySingleTagSilently(HANDLE hCom, unsigned char* tagID,BYTE ReaderAddr)
{
	bool ret = false;
	buffer[0] = 0xA0;
	buffer[1] = 0x03;
	buffer[2] = 0xA1;
	buffer[3] = ReaderAddr;
	buffer[4] = ::GetCheckSum(buffer, 4);
	::COMMPurgeComm(hCom);
	if(::COMMSendData(hCom, (const char*)buffer, 5) == 5)
	{
		::memset(buffer, 0, 18 * sizeof(unsigned char));
		if(::COMMReceiveData(hCom, (char*)buffer, 18) == 18)
		{
			if(	   buffer[0] == 0xE0 
				&& buffer[1] == 0x10 
				&& buffer[2] == 0xA1 
	//			&& buffer[3] == 0x01 
				&& buffer[17] == ::GetCheckSum(buffer, 17)	)
				::memcpy(tagID, &buffer[5], LEN_Tag);
				ret = true;
		}
	}
	return ret;
}

bool ReadTagEPCSectionData(HANDLE hCom, unsigned char* tagID,BYTE ReaderAddr)
{
	bool ret = false;
	buffer[0] = 0xA0;
	buffer[1] = 0x06;
	buffer[2] = 0x80;
	buffer[3] = ReaderAddr;
	buffer[4] = 0x01;	// EPC Section
	buffer[5] = 0x02;	// Address
	buffer[6] = 0x04;	// Length
	buffer[7] = ::GetCheckSum(buffer, 7);
	::COMMPurgeComm(hCom);
	if(::COMMSendData(hCom, (const char*)buffer, 8) == 8)
	{
		::memset(buffer, 0, 16 * sizeof(unsigned char));
		if(::COMMReceiveData(hCom, (char*)buffer, 16) == 16)
		{
			if(	   buffer[0] == 0xE0 
				&& buffer[1] == 0x0F 
				&& buffer[2] == 0x80 
//				&& buffer[3] == 0x04  
				&& buffer[4] == 0x01 
				&& buffer[5] == 0x02 
				&& buffer[6] == 0x04 
				&& buffer[15] == ::GetCheckSum(buffer, 15)	)
				::memcpy(tagID, &buffer[7], LEN_TagEPCData);
				ret = true;
		}
	}
	return ret;
}

bool GetLoginPassword(HANDLE hCom, unsigned char* password,BYTE ReaderAddr)
{
	bool ret = false;
	buffer[0] = 0xA0;
	buffer[1] = 0x02;
	buffer[2] = 0x9D;
	buffer[3] = ReaderAddr;
	buffer[4] = GetCheckSum(buffer, 4);
	::COMMPurgeComm(hCom);
	if(::COMMSendData(hCom, (const char*)buffer, 5) == 5)
	{
		::memset(buffer, 0, 9 * sizeof(unsigned char));
		if(::COMMReceiveData(hCom, (char*)buffer, 9) == 9)
		{
			if(	   buffer[0] == 0xE0 
				&& buffer[1] == 0x06 
				&& buffer[2] == 0x9D 
				&& buffer[8] == GetCheckSum(buffer, 8)	)
				for(int i = 0; i < 4; i++)
					password[i] = buffer[4 + i];
				ret = TRUE;
		}
	}
	return ret;
}

bool SetLoginPassword(HANDLE hCom, const unsigned char* password,BYTE ReaderAddr)
{
	bool ret = false;
	buffer[0] = 0xA0;
	buffer[1] = 0x06;
	buffer[2] = 0x9E;
	buffer[3]=  ReaderAddr;
	buffer[4] = password[0];
	buffer[5] = password[1];
	buffer[6] = password[2];
	buffer[7] = password[3];
	buffer[8] = GetCheckSum(buffer, 8);
	::COMMPurgeComm(hCom);
		
	if(::COMMSendData(hCom, (const char*)buffer, 9) == 9)
	{
		::memset(buffer, 0, 6 * sizeof(unsigned char));
		if(::COMMReceiveData(hCom, (char*)buffer, 6) == 6)
		{
			if(	   buffer[0] == 0xE0 
				&& buffer[1] == 0x04 
				&& buffer[2] == 0x9E 
				&& buffer[5] == GetCheckSum(buffer, 5)	)
				if(buffer[4] == 0x00)
					ret = TRUE;
		}
	}
	return ret;
}


//A0 06 63 00 05 00 20 D2 Ʒʶѯ
//ӻأ(E0 0B 63) ͷ( 00) usercode 05 00 20 (38 32 32 30 FF) ֵ (C2) checksum

bool GetReaderParameters(HANDLE hCom, int addr, int paramNum, BYTE* params,BYTE ReaderAddr)
{
	bool ret = FALSE;
	buffer[0] = 0xA0;
	buffer[1] = 0x06;
	buffer[2] = 0x63;
	buffer[3] = ReaderAddr; //<xxm 110715
	buffer[4] = (unsigned char)paramNum;
	buffer[5] = 0x00;
	buffer[6] = (unsigned char)addr;
	buffer[7] = GetCheckSum(buffer, 7);
	::COMMPurgeComm(hCom);
	if(::COMMSendData(hCom, (const char*)buffer, 8) == 8)
	{
		int correctRecvNum = 6 + paramNum + 2;
		::memset(buffer, 0, correctRecvNum * sizeof(unsigned char));
		if(::COMMReceiveData(hCom, (char*)buffer, correctRecvNum) == correctRecvNum)
		{
			if(	   buffer[0] == 0xE0 
				&& buffer[1] == (unsigned char)(correctRecvNum - 2) 
				&& buffer[2] == 0x63 
				&& buffer[4] == (unsigned char)paramNum 
				&& buffer[5] == 0x00 
				&& buffer[6] == (unsigned char)addr 
				&& buffer[correctRecvNum - 1] == GetCheckSum(buffer, correctRecvNum - 1)	)
				
				for(int i = 0; i < paramNum; i++)
					params[i] = buffer[i + 6];
				ret = TRUE;
		}
	}
	return ret;
}

//磺A0 0E 62 00 08 00 92 01 04 10 40 00 01 02 01 FD (Ƶ)
//ӻأE4 04 62 00 usercode00 statusB6Checksum    
BOOL SetReaderParameters(HANDLE hCom, int addr, int paramNum, const BYTE* params,BYTE ReaderAddr)
{
	BOOL ret = FALSE;
	int sendNum = paramNum + 8;
	buffer[0] = 0xA0;
	buffer[1] = (BYTE)(sendNum - 2);
	buffer[2] = 0x62;
  buffer[3] = ReaderAddr;				//usercode
	buffer[4] = (BYTE)paramNum;
	buffer[5] = 0x00;
	buffer[6] = (BYTE)addr;

	for(int i = 0; i < paramNum; i++)
		buffer[7 + i] = params[i];

	buffer[sendNum - 1] = GetCheckSum(buffer, sendNum - 1);
	::COMMPurgeComm(hCom);
	if(::COMMSendData(hCom, (const char*)buffer, sendNum) == sendNum)
	{
		::memset(buffer, 0, 6 * sizeof(BYTE));
		if(::COMMReceiveData(hCom, (char*)buffer, 6) == 6)
		{
			if(	   buffer[0] == 0xE4 
				&& buffer[1] == 0x04 
				&& buffer[2] == 0x62 
				&& buffer[4] == 0x00  
				&& buffer[5] == GetCheckSum(buffer, 5)	)
				ret = TRUE;
		}
	}
	return ret;
}

bool GetAuthorizationCode(HANDLE hCom, unsigned char* code,BYTE ReaderAddr)
{
	/*
	bool ret = false;
	buffer[0] = 0xA0;
	buffer[1] = 0x05;
	buffer[2] = 0x63;
	buffer[3] = 0x02;
	buffer[4] = 0x00;
	buffer[5] = 0xBA;
	buffer[6] = GetCheckSum(buffer, 6);
	::COMMPurgeComm(hCom);
	if(::COMMSendData(hCom, (const char*)buffer, 7) == 7)
	{
		::memset(buffer, 0, 9 * sizeof(unsigned char));
		if(::COMMReceiveData(hCom, (char*)buffer, 9) == 9)
		{
			if(	   buffer[0] == 0xE0 
				&& buffer[1] == 0x07 
				&& buffer[2] == 0x63 
				&& buffer[3] == 0x02
				&& buffer[4] == 0x00
				&& buffer[5] == 0xBA
				&& buffer[8] == GetCheckSum(buffer, 8)	)
				for(int i = 0; i < 2; i++)
					code[i] = buffer[6 + i];
				ret = TRUE;
		}
	}
	return ret;
	*/
   return  GetReaderParameters(hCom, 0xba, 2, code,ReaderAddr);
}

bool SetAuthorizationCode(HANDLE hCom, const unsigned char* code,BYTE ReaderAddr)
{
	bool ret = false;
	buffer[0] = 0xA0;
	buffer[1] = 0x05;
	buffer[2] = 0x9B;
	buffer[3] = ReaderAddr;
	buffer[4] = code[0];
	buffer[5] = code[1];
	buffer[6] = GetCheckSum(buffer, 6);
	::COMMPurgeComm(hCom);
	if(::COMMSendData(hCom, (const char*)buffer, 7) == 7)
	{
		::memset(buffer, 0, 6 * sizeof(unsigned char));
		if(::COMMReceiveData(hCom, (char*)buffer, 6) == 6)
		{
			if(	   buffer[0] == 0xE4 
				&& buffer[1] == 0x04 
				&& buffer[2] == 0x9B 
				
				&& buffer[5] == GetCheckSum(buffer, 5)	)
				if(buffer[4] == 0x00)
					ret = TRUE;
		}
	}
	return ret;
}

bool AuthorizeTag(HANDLE hCom,BYTE ReaderAddr)
{
	bool ret = false;
	buffer[0] = 0xA0;
	buffer[1] = 0x03;
	buffer[2] = 0x9A;
	buffer[3] = ReaderAddr;
	buffer[4] = ::GetCheckSum(buffer, 4);
	::COMMPurgeComm(hCom);
	if(::COMMSendData(hCom, (const char*)buffer, 5) == 5)
	{
		::memset(buffer, 0, 6 * sizeof(unsigned char));
		if(::COMMReceiveData(hCom, (char*)buffer, 6) == 6)
		{
			if(	   buffer[0] ==0xE4 
				&& buffer[1] == 0x04
				&& buffer[2] == 0x9A 
				&& buffer[5] == ::GetCheckSum(buffer, 5)	)
				if(buffer[4] == 0x00)
					ret = true;
		}
	}
	return ret;
}

// ͣA0  08  9C  00  02  12  34  56  78  A6 
// أ    E0 04 9C  usercode  status  checksum
//---------------------------------------------------------------------------------
bool FastWriteTagID(HANDLE hCom, int bytesNum, const BYTE* bytes,BYTE ReaderAddr)
{
	bool ret = FALSE;
	if(bytesNum > 0 && (bytesNum % 2) == 0 && bytes != NULL)
	{
		buffer[0] = 0xA0;
		buffer[1] = 4 + bytesNum;
		buffer[2] = 0x9C;
        buffer[3] = ReaderAddr;
		buffer[4] = bytesNum / 2;
		for(int i = 0; i < bytesNum; i++)
			buffer[5 + i] = bytes[i];
		buffer[5 + bytesNum] = GetCheckSum(buffer, 5 + bytesNum);
		::COMMPurgeComm(hCom);
		if(::COMMSendData(hCom, (const char*)buffer, 6 + bytesNum) == 6 + bytesNum)
		{
			::memset(buffer, 0, 6 * sizeof(BYTE));
			if(::COMMReceiveData(hCom, (char*)buffer, 6) == 6)
			{
				if(	   buffer[0] == 0xE0 
					&& buffer[1] == 0x04 
					&& buffer[2] == 0x9C 
					&& buffer[4] == 0x00 
					&& buffer[5] == GetCheckSum(buffer, 5)	)
					ret = TRUE;
			}
		}
	}
	return ret;
}

bool FastWriteTagID_Lock(HANDLE hCom, int bytesNum, const unsigned char* bytes)
{
	bool ret = false;
	if(bytesNum > 0 && (bytesNum % 2) == 0 && bytes != NULL)
	{
		buffer[0] = 0xA0;
		buffer[1] = 3 + bytesNum;
		buffer[2] = 0x9F;
		buffer[3] = bytesNum / 2;
		for(int i = 0; i < bytesNum; i++)
			buffer[4 + i] = bytes[i];
		buffer[4 + bytesNum] = GetCheckSum(buffer, 4 + bytesNum);
		::COMMPurgeComm(hCom);
		if(::COMMSendData(hCom, (const char*)buffer, 5 + bytesNum) == 5 + bytesNum)
		{
			::memset(buffer, 0, 5 * sizeof(unsigned char));
			if(::COMMReceiveData(hCom, (char*)buffer, 5) == 5)
			{
				if(	   buffer[0] == 0xE0 
					&& buffer[1] == 0x03 
					&& buffer[2] == 0x9F 
					&& buffer[3] == 0x00 
					&& buffer[4] == GetCheckSum(buffer, 4)	)
					ret = TRUE;
			}
		}
	}
	return ret;
}
// A0 03 A8 00 B5
//ӻأ       E0  04  A8  usercode  status  checksum
BOOL StopReading(HANDLE hCom,BYTE ReaderAddr)
{
	BOOL ret = FALSE;
	buffer[0] = 0xA0;
	buffer[1] = 0x03;
	buffer[2] = 0xA8; 
  buffer[3] = ReaderAddr; 
	buffer[4] = ::GetCheckSum(buffer, 4);
	::COMMPurgeComm(hCom);
	if(::COMMSendData(hCom, (const char*)buffer, 5) == 5)
	{
		::memset(buffer, 0, 6 * sizeof(BYTE));
		if(::COMMReceiveData(hCom, (char*)buffer, 6) == 6)
		{
			if(	   buffer[0] == 0xE0 
                && buffer[1] == 0x04 
				&& buffer[2] == 0xA8
				&& buffer[4] == 0x00 		
				&& buffer[5] == ::GetCheckSum(buffer, 5)	)
				ret = TRUE;
		}
	}
	return ret;
}

//ͣ A0 06 80 00 01 02 01 D6; 0x02ַʼ𣬶ȡ1ֵݡ
//ӻأ   E0 08 80 00 01 02 01 55 55 EA 
BOOL ReadTag(HANDLE hCom, BYTE memBank, BYTE address, BYTE length, BYTE* data,BYTE ReaderAddr)
{
	BOOL ret = FALSE;
	buffer[0] = 0xA0;
	buffer[1] = 0x06;
	buffer[2] = 0x80;
	buffer[3] = ReaderAddr;
	buffer[4] = memBank;
	buffer[5] = address;
	buffer[6] = length;
	buffer[7] = ::GetCheckSum(buffer, 7);
	::COMMPurgeComm(hCom);
	if(::COMMSendData(hCom, (const char*)buffer, 8) == 8)
	{
		int expectedRecvLen = length * 2 + 8;
		::memset(buffer, 0, expectedRecvLen * sizeof(BYTE));
		if(::COMMReceiveData(hCom, (char*)buffer, expectedRecvLen) == expectedRecvLen)
		{
			if(	   buffer[0] == 0xE0 
				&& buffer[2] == 0x80 
//				&& buffer[3] == 0x04 
				&& buffer[expectedRecvLen - 1] == ::GetCheckSum(buffer, expectedRecvLen - 1)	)
				::memcpy(data, &buffer[7], length * 2);
				ret = TRUE;
		}
	}
	return ret;
}

//A0 08 A5 00 12 34 56 78 03 9C
//ӻأ E4  04  A5  usercode  status  checksum
BOOL LockPassWordTag(HANDLE hCom,BYTE passwd1,BYTE passwd2,BYTE passwd3,BYTE passwd4,BYTE lockType,BYTE ReaderAddr)
{
	BOOL ret = FALSE;
	buffer[0] = 0xA0;
	buffer[1] = 0x08;
	buffer[2] = 0xA5;
	buffer[3] = ReaderAddr;
  buffer[4] = passwd1;
  buffer[5] = passwd2;
  buffer[6] = passwd3;
	buffer[7] = passwd4;
	buffer[8] = lockType;
	buffer[9] = ::GetCheckSum(buffer, 9);
	::COMMPurgeComm(hCom);
	if(::COMMSendData(hCom, (const char*)buffer, 10) == 10)
	{
		::memset(buffer, 0, 6 * sizeof(BYTE));
		if(::COMMReceiveData(hCom, (char*)buffer, 6) == 6)
		{
			if(	   buffer[0] == 0xE4 
				&& buffer[1] == 0x04 
				&& buffer[2] == 0xA5 
				&& buffer[4] == 0x00 
				&& buffer[5] == ::GetCheckSum(buffer, 5)	)
				ret = TRUE;
		}
	}
	return ret;
}

//<xxm 110719
BOOL UnlockPassWordTag(HANDLE hCom,BYTE passwd1,BYTE passwd2,BYTE passwd3,BYTE passwd4,BYTE lockType,BYTE ReaderAddr)
{
	BOOL ret = FALSE;
	buffer[0] = 0xA0;
	buffer[1] = 0x08;
	buffer[2] = 0xA6;
    buffer[3] = ReaderAddr;
    buffer[4] = passwd1;
    buffer[5] = passwd2;
    buffer[6] = passwd3;
	buffer[7] = passwd4;
	buffer[8] = lockType;
	buffer[9] = ::GetCheckSum(buffer, 9);
	::COMMPurgeComm(hCom);
	if(::COMMSendData(hCom, (const char*)buffer, 10) == 10)
	{
		::memset(buffer, 0, 6 * sizeof(BYTE));
		if(::COMMReceiveData(hCom, (char*)buffer, 6) == 6)
		{
			if(	   buffer[0] == 0xE4 
				&& buffer[1] == 0x04 
				&& buffer[2] == 0xA6 
				&& buffer[4] == 0x00 
				&& buffer[5] == ::GetCheckSum(buffer, 5)	)
				ret = TRUE;
		}
	}
	return ret;
}
//<xxm 110719
bool IdentifyUploadedSingleTag(HANDLE hCom, BYTE* tagID, BYTE* devNo, BYTE* antennaNo)
{
	bool ret = FALSE;
	::memset(buffer, 0, LEN_Tag * sizeof(BYTE));
	if(::COMMReceiveData(hCom, (char*)buffer, 17) == 17)
	{
		if(	   buffer[0] == 0x00 
			&& buffer[15] == ::GetCheckSum(buffer, 15)	
			&& buffer[16] == 0xFF )
		{
			::memcpy(tagID, &buffer[2], LEN_Tag);
			if(devNo != NULL)
				*devNo = buffer[1];
			if(antennaNo != NULL)
				*antennaNo = buffer[14];
			ret = TRUE;
		}
	}
	return ret;
}