
// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the EPCSDK_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// EPCSDK_API functions as being imported from a DLL, wheras this DLL sees symbols
// defined with this macro as being exported.
#ifdef EPCSDK_EXPORTS
#define EPCSDK_API __declspec(dllexport)
#else
#define EPCSDK_API __declspec(dllimport)
#endif

extern "C" EPCSDK_API HANDLE OpenComm(int portNo);	// COM 1-9. Return -1(INVALID_HANDLE_VALUE) if failed.
extern "C" EPCSDK_API void	 CloseComm(HANDLE hCom);
extern "C" EPCSDK_API bool	 ReadFirmwareVersion(HANDLE hCom, int* main, int* sub,BYTE ReaderAddr);
extern "C" EPCSDK_API BOOL	 StopReading(HANDLE hCom,BYTE ReaderAddr);
extern "C" EPCSDK_API bool	 StopReadingTag(HANDLE hCom,BYTE ReaderAddr);
extern "C" EPCSDK_API bool	 StopWorking(HANDLE hCom,BYTE ReaderAddr);
extern "C" EPCSDK_API bool	 ResetReader(HANDLE hCom,BYTE ReaderAddr);
extern "C" EPCSDK_API bool	 IdentifySingleTag(HANDLE hCom, unsigned char* tagID,BYTE ReaderAddr);			// tagID = 12 Bytes
extern "C" EPCSDK_API bool	 IdentifySingleTagSilently(HANDLE hCom, unsigned char* tagID,BYTE ReaderAddr);	// tagID =  12 Bytes
extern "C" EPCSDK_API bool	 ReadTagEPCSectionData(HANDLE hCom, unsigned char* tagID,BYTE ReaderAddr);		// tagID =  8 Bytes
extern "C" EPCSDK_API BOOL	 ReadTag(HANDLE hCom, BYTE memBank, BYTE address, BYTE length, BYTE* data,BYTE ReaderAddr);
extern "C" EPCSDK_API bool	 GetLoginPassword(HANDLE hCom, unsigned char* password,BYTE ReaderAddr);		// password = 4 Bytes
extern "C" EPCSDK_API bool	 SetLoginPassword(HANDLE hCom, const unsigned char* password,BYTE ReaderAddr);	// password = 4 Bytes

extern "C" EPCSDK_API bool	 GetAuthorizationCode(HANDLE hCom, unsigned char* code,BYTE ReaderAddr);		// code = 2 Bytes
extern "C" EPCSDK_API bool	 SetAuthorizationCode(HANDLE hCom, const unsigned char* code,BYTE ReaderAddr);	// code = 2 Bytes
extern "C" EPCSDK_API bool	 AuthorizeTag(HANDLE hCom,BYTE ReaderAddr);
extern "C" EPCSDK_API BOOL   LockPassWordTag(HANDLE hCom,BYTE passwd1,BYTE passwd2,BYTE passwd3,BYTE passwd4,BYTE lockType,BYTE ReaderAddr);// lockType => 00: LOCK USER, 01: LOCK TID, 02: LOCK EPC, 03: LOCK ACCESS, 04: LOCK KILL, 05: LOCK ALL, other: DO NOT LOCK
extern "C" EPCSDK_API BOOL   UnlockPassWordTag(HANDLE hCom,BYTE passwd1,BYTE passwd2,BYTE passwd3,BYTE passwd4,BYTE lockType,BYTE ReaderAddr);// lockType => 00: LOCK USER, 01: LOCK TID, 02: LOCK EPC, 03: LOCK ACCESS, 04: LOCK KILL, 05: LOCK ALL, other: DO NOT LOCK
extern "C" EPCSDK_API bool	 FastWriteTagID(HANDLE hCom, int bytesNum, const unsigned char* bytes,BYTE ReaderAddr);	// 2, 4, 6, 8, 10, 12 Bytes
extern "C" EPCSDK_API bool	 FastWriteTagID_Lock(HANDLE hCom, int bytesNum, const unsigned char* bytes,BYTE ReaderAddr);	// 2, 4, 6, 8, 10, 12 Bytes