
// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the EPCSDK_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// EPCSDK_API functions as being imported from a DLL, wheras this DLL sees symbols
// defined with this macro as being exported.
#ifdef EPCSDK_EXPORTS
#define EPCSDK_API __declspec(dllexport)
#else
#define EPCSDK_API __declspec(dllimport)
#endif

extern "C" EPCSDK_API HANDLE __stdcall OpenComm(int portNo);	// COM 1-9. Return -1(INVALID_HANDLE_VALUE) if failed.
extern "C" EPCSDK_API void  __stdcall CloseComm(HANDLE hCom);
extern "C" EPCSDK_API BOOL __stdcall ReadFirmwareVersion(HANDLE hCom, int* main, int* sub,BYTE ReaderAddr);

extern "C" EPCSDK_API BOOL __stdcall GetReaderParameters(HANDLE hCom, int addr, int paramNum, BYTE* params,BYTE ReaderAddr);
extern "C" EPCSDK_API BOOL __stdcall SetReaderParameters(HANDLE hCom, int addr, int paramNum, const BYTE* params,BYTE ReaderAddr);

extern "C" EPCSDK_API BOOL __stdcall StopReading(HANDLE hCom,BYTE ReaderAddr);
extern "C" EPCSDK_API BOOL __stdcall ResumeReading(HANDLE hCom,BYTE ReaderAddr);

extern "C" EPCSDK_API BOOL __stdcall  IdentifySingleTag(HANDLE hCom, BYTE* tagID, BYTE* antennaNo,BYTE ReaderAddr);	// tagID: 12 Bytes, antennaNo: 1 Byte
extern "C" EPCSDK_API BOOL __stdcall  IdentifyUploadedSingleTag(HANDLE hCom, BYTE* tagID, BYTE* devNo=NULL, BYTE* antennaNo=NULL);	// tagID: 12 Bytes, devNo: 1 Byte, antennaNo: 1 Byte
extern "C" EPCSDK_API BOOL __stdcall  IdentifyUploadedMultiTags(HANDLE hCom, BYTE* tagNum, BYTE* tagIDs, BYTE* devNos=NULL, BYTE* antennaNos=NULL);	// tagNum : 1 Byte, tagIDs: N * 12 Bytes, devNos: N Bytes, antennaNos: N Bytes (N < 50)

extern "C" EPCSDK_API BOOL __stdcall  ReadTIDByEpcID(HANDLE hCom, const BYTE* bytes,BYTE* data,BYTE ReaderAddr);
extern "C" EPCSDK_API BOOL __stdcall  ReadByEpcID(HANDLE hCom, BYTE memBank, BYTE address, BYTE WordCount,const BYTE* EpcID, BYTE* data,BYTE ReaderAddr);

extern "C" EPCSDK_API BOOL __stdcall  ReadTag(HANDLE hCom, BYTE memBank, BYTE address, BYTE length, BYTE* data,BYTE ReaderAddr);
extern "C" EPCSDK_API BOOL __stdcall  WriteTagSingleWord(HANDLE hCom, BYTE memBank, BYTE address, BYTE data1, BYTE data2,BYTE ReaderAddr);
extern "C" EPCSDK_API BOOL __stdcall  WriteByEpcID(HANDLE hCom, BYTE memBank, BYTE address, BYTE WordCount,const BYTE* EpcID,BYTE* data,BYTE ReaderAddr);//<xxm 110814
extern "C" EPCSDK_API BOOL __stdcall  WriteTagMultiWord(HANDLE hCom, BYTE memBank, BYTE address, BYTE WordCount,const BYTE* bytes,BYTE ReaderAddr); //<XXM 110425
extern "C" EPCSDK_API BOOL __stdcall  FastWriteTagID(HANDLE hCom, int bytesNum, const BYTE* bytes,BYTE ReaderAddr);		// 2, 4, 6, 8, 10, 12 Bytes
extern "C" EPCSDK_API BOOL __stdcall  FastWriteTagID_Lock(HANDLE hCom, int bytesNum, const BYTE* bytes,BYTE ReaderAddr);	// 2, 4, 6, 8, 10, 12 Bytes
extern "C" EPCSDK_API BOOL __stdcall  FastWriteTag(HANDLE hCom, BYTE memBank, BYTE address, BYTE WordCount,const BYTE* bytes,BYTE ReaderAddr);
extern "C" EPCSDK_API BOOL __stdcall  InitializeTag(HANDLE hCom,BYTE ReaderAddr);
//extern "C" EPCSDK_API BOOL __stdcall  LockTag(HANDLE hCom, BYTE lockType,BYTE ReaderAddr);	// lockType => 00: LOCK USER, 01: LOCK TID, 02: LOCK EPC, 03: LOCK ACCESS, 04: LOCK KILL, 05: LOCK ALL, other: DO NOT LOCK
extern "C" EPCSDK_API BOOL __stdcall  LockPassWordTag(HANDLE hCom,BYTE passwd1,BYTE passwd2,BYTE passwd3,BYTE passwd4,BYTE lockType,BYTE ReaderAddr);// lockType => 00: LOCK USER, 01: LOCK TID, 02: LOCK EPC, 03: LOCK ACCESS, 04: LOCK KILL, 05: LOCK ALL, other: DO NOT LOCK
extern "C" EPCSDK_API BOOL __stdcall  UnlockPassWordTag(HANDLE hCom,BYTE passwd1,BYTE passwd2,BYTE passwd3,BYTE passwd4,BYTE lockType,BYTE ReaderAddr);// lockType => 00: LOCK USER, 01: LOCK TID, 02: LOCK EPC, 03: LOCK ACCESS, 04: LOCK KILL, 05: LOCK ALL, other: DO NOT LOCK
extern "C" EPCSDK_API BOOL __stdcall  KillTag(HANDLE hCom, BYTE passwd1, BYTE passwd2, BYTE passwd3, BYTE passwd4,BYTE ReaderAddr);
extern "C" EPCSDK_API BOOL __stdcall  BeepCtrl(HANDLE hCom,BYTE BeepStatus,BYTE ReaderAddr);
extern "C" EPCSDK_API BOOL __stdcall  RelayCtrl(HANDLE hCom,BYTE RelayOnOff,BYTE ReaderAddr); //<xxm 110922
