﻿using System;
using System.Text;
using System.Windows.Forms;
using System.Collections.Generic;
using System.Net;
using System.Net.Sockets;

namespace SocketClient
{
    public partial class frmClient : Form
    {
        private Socket m_clientSocket;
        private byte[] m_receiveBuffer = new byte[1024];
        private string mydate;
        public frmClient()
        {
            InitializeComponent();
            Control.CheckForIllegalCrossThreadCalls = false;
        }

        private void frmClient_Load(object sender, EventArgs e)
        {
            txtIP.Text = "192.168.0.172";
            txtPort.Text = "27011";
        }

        /// <summary>
        /// 连接服务器
        /// </summary>
        private void btnConnect_Click(object sender, EventArgs e)
        {
            string serverIP = txtIP.Text;
            int serverPort = Int32.Parse(txtPort.Text);

            m_clientSocket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            IPEndPoint remoteEndPoint = new IPEndPoint(IPAddress.Parse(serverIP),serverPort);

            try
            {
                m_clientSocket.Connect(remoteEndPoint);
                if (m_clientSocket.Connected)
                {
                    m_clientSocket.BeginReceive(m_receiveBuffer, 0, m_receiveBuffer.Length, 0, new AsyncCallback(ReceiveCallBack), null);

                    btnConnect.Enabled = false;
                    btnDisconnect.Enabled = true;

                    this.AddRunningInfo(">> " + DateTime.Now.ToString() + " Client connect server success.");
                }
            }
            catch (Exception)
            {
                this.AddRunningInfo(">> " + DateTime.Now.ToString() + " Client connect server fail.");
                m_clientSocket = null;
            }
        }

        /// <summary>
        /// 断开连接
        /// </summary>
        private void btnDisconnect_Click(object sender, EventArgs e)
        {
            if (m_clientSocket != null)
            {
                m_clientSocket.Close();

                btnConnect.Enabled = true;
                btnDisconnect.Enabled = false;
                btnSend.Enabled = false;

                this.AddRunningInfo(">> " + DateTime.Now.ToString() + " Client disconnected.");
            }
        }

        /// <summary>
        /// 发送信息
        /// </summary>
        private void btnSend_Click(object sender, EventArgs e)
        {
            string strSendData = txtSend.Text+",";
            byte[] sendBuffer = new byte[1024];
            sendBuffer = Encoding.Unicode.GetBytes(strSendData);

            if (m_clientSocket != null)
            {
                m_clientSocket.Send(sendBuffer);
            }
        }

        private void ReceiveCallBack(IAsyncResult ar)
        {
            try
            {
                int REnd = m_clientSocket.EndReceive(ar);

                string tmpString = "";
                string strReceiveData="";
                int macNum=0 ;
                int x = 0;
                int y = 0;
                int z = 0;
                int con=0;
                for (int i = 1; i < REnd-11 ; i++)
                {
                    tmpString += m_receiveBuffer[i].ToString("x");
                   
                  //  tmpString += (m_receiveBuffer[i] & 0x7f).ToString("x");
                }
                if (tmpString.Length == 10)
                {
                     strReceiveData = tmpString.Substring(2, 8);       
                     macNum = Convert.ToInt32(tmpString.Substring(0, 2), 16);//把字符转成16进制

                     //while (macNum >= 100)
                     //{
                     //    macNum = macNum - 0X64;
                     //    x += 1;
                     //}

                     //while (macNum >= 10)
                     //{
                     //    macNum = macNum - 0X0A;
                     //    y += 1;
                     //}

                    // z = macNum;


                 
               
                }
                else if (tmpString.Length < 10)
                {
                    strReceiveData = tmpString.Substring(1, 8);
                    macNum = Convert.ToInt32(tmpString.Substring(0, 1), 16);//转成16进制
                    //while (macNum >= 100)
                    //{
                    //    macNum = macNum - 0X64;
                    //    x += 1;
                    //}

                    //while (macNum >= 10)
                    //{
                    //    macNum = macNum - 0X0A;
                    //    y += 1;
                    //}

                    //z = macNum;

                  

                }
              
                tmpString = "";
                Convert.ToInt32(strReceiveData, 16);//
           
                this.HandleMessage(strReceiveData + " 机器号：" + macNum);
              
                m_clientSocket.BeginReceive(m_receiveBuffer, 0, m_receiveBuffer.Length, 0, new AsyncCallback(ReceiveCallBack), null);
            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message);
            }
        }

        /// <summary>
        /// 处理接收到的数据
        /// </summary>
        private void HandleMessage(string message)
        {
           // message = message.Replace("\0", "");
            if (!string.IsNullOrEmpty(message))
            {
                this.AddRunningInfo(">> Receive Data from server:" + message);
            }
        }

        /// <summary>
        /// 返回不带参数的  数据
        /// 
        /// </summary>
        /// <param name="message"></param>
        private string  HandleMessage_nnnnns()
        {

            this.AddRunningInfo(">> Receive Data from server:" + mydate);
            return mydate;
          
        }
        private void AddRunningInfo(string message)
        {
            lstRunningInfo.BeginUpdate();
            lstRunningInfo.Items.Insert(0, message);

            if (lstRunningInfo.Items.Count > 100)
            {
                lstRunningInfo.Items.RemoveAt(100);
            }

            lstRunningInfo.EndUpdate();
        }

        private void txtSend_TextChanged(object sender, EventArgs e)
        {
            if (!string.IsNullOrEmpty(txtSend.Text) && m_clientSocket!=null)
            {
                btnSend.Enabled = true;
            }
            else
            {
                btnSend.Enabled = false;
            }
        }

        private void txtIP_TextChanged(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
           string aa= HandleMessage_nnnnns();
           MessageBox.Show(aa);
        }

        /// <summary>
        /// 16进制转10进制
        /// </summary>
        /// <param name="hex"></param>
        /// <returns></returns>
        public static int Hex2Ten(string hex)
        {
            int ten = 0;
            for (int i = 0, j = hex.Length - 1; i < hex.Length; i++)
            {
                ten += HexChar2Value(hex.Substring(i, 1)) * ((int)Math.Pow(16, j));
                j--;
            }
            return ten;
        }

        public static int HexChar2Value(string hexChar)
        {
            switch (hexChar)
            {
                case "0":
                case "1":
                case "2":
                case "3":
                case "4":
                case "5":
                case "6":
                case "7":
                case "8":
                case "9":
                    return Convert.ToInt32(hexChar);
                case "a":
                case "A":
                    return 10;
                case "b":
                case "B":
                    return 11;
                case "c":
                case "C":
                    return 12;
                case "d":
                case "D":
                    return 13;
                case "e":
                case "E":
                    return 14;
                case "f":
                case "F":
                    return 15;
                default:
                    return 0;
            }
        }


    }
}
